


#include "Date.h"
#include "Date_User.h"
#include "inttypes.h"

uint8_t Date_Month_Text[]={'J','a','n','u','a','r','\n',
                           'F','e','b','r','u','a','r','\n',
                           'M','','r','z','\n',
                           'A','p','r','i','l','\n',
                           'M','a','i','\n',
                           'J','u','n','i','\n',
                           'J','u','l','i','\n',
                           'A','u','g','u','s','t','\n',
                           'S','e','p','t','e','m','b','e','r','\n',
                           'O','k','t','o','b','e','r','\n',
                           'N','o','v','e','m','b','e','r','\n',
                           'D','e','z','e','m','b','e','r','\n'};

uint8_t * Date_Get_Month_Text_Pointer(uint8_t month)
{
    uint8_t * p_Text=Date_Month_Text;
    if(month)
    {
        if(month>12)
        {
            return p_Text;
        }
        else
        {
            month--;
            while(month)
            {
                if(*p_Text=='\n')
                {
                    month--;
                }
                p_Text++;
            }
            return p_Text;
        }
    }
    else
    {
        return p_Text;
    }
}

uint8_t Date_Calc_Get_Last_Week_In_Year (date_t* p_date)
{
    date_t date_locdate;

    date_locdate.day=31;
    date_locdate.month=12;
    date_locdate.year=p_date->year;
    Date_Calc_Calweek(&date_locdate);

    return date_locdate.calweek;
}

uint8_t Date_Calc_Get_First_Week_In_Month (date_t* p_date)
{
    date_t date_locdate;

    date_locdate.day=1;
    date_locdate.month=p_date->month;
    date_locdate.year=p_date->year;
    Date_Calc_Calweek(&date_locdate);

    return date_locdate.calweek;
}

uint8_t Date_Calc_Get_First_Day_In_Month (date_t* p_date)
{
    date_t date_locdate;

    date_locdate.day=1;
    date_locdate.month=p_date->month;
    date_locdate.year=p_date->year;
    Date_Calc_Week(&date_locdate);

    return date_locdate.week;
}
