


#include <inttypes.h>

#include "Font.h"
#include "8_3x5.h"
#include "ArialFett8.h"
//#include "Date_User.h"

#define FONT_BACKGROUND_COL     0x00


unsigned char powerof2[8] PROGMEM = {1,2,4,8,16,32,64,128};

glcdData_t Font;

/*************************************************************************/
/* FONT FUNCTOINS                                    */
/*************************************************************************/
void Font_Write_Char_Old(unsigned char x, unsigned char y, unsigned char color,char letter,uint8_t mode)
{
    unsigned char x_run,y_run,testbyte,countbyte,countx,offset;
    unsigned int index,widthlength;
    uint8_t * pFont=FONT_8_3x5;
    //index=147; //101 entspricht 00   138=0
    
    //  letter-=FONT_8_3x5[5]; //anfangsbuchstabernoffset abziehen
    letter-=pgm_read_byte(pFont+5);

    //letter++;
    offset=0;
    index=7;//first width byte
    while(letter)
    {
        //offset+=FONT_8_3x5[index];
        offset+=pgm_read_byte(pFont+index);
        index++;
        letter--;
    }

    //berechnung anfang des datenfeldes

    //widthlength=FONT_8_3x5[6]-FONT_8_3x5[5]+1;
    widthlength=pgm_read_byte(pFont+6)-pgm_read_byte(pFont+5)+1;

    //countx=FONT_8_3x5[index]; //breite des buchstaben
    countx=pgm_read_byte(pFont+index);

    x_run=x;
    index=7+widthlength+offset;//errechnung erstes byte des buchstaben

    //testbyte=FONT_8_3x5[index];
    testbyte=pgm_read_byte(pFont+index);


    while(countx)
    {
        countbyte=5;
        y_run=y;
        while(countbyte)
        {
            /*if(testbyte&0x80)
            {
                SLM1606_setPixel(x_run,y_run,color);
                //SLM1606_setPixel(x,y,color);
            }
            else
            {
                if(mode)
                SLM1606_setPixel(x_run,y_run,0x00);
            }*/
            if(testbyte&0x80)
                SLM1606_Set_Pixel(x_run,y_run,color,mode);
            y_run++;
            testbyte<<=1;
            countbyte--;
        }
        x_run++;
        countx--;
        index++;
        //testbyte=FONT_8_3x5[index];
        testbyte=pgm_read_byte(pFont+index);
    }
}
//void pgm_read_byte_inc(unsigned int *data)
/*void glcdSelectFont(const void* data) {

    glcdFontData_t d = (glcdFontData_t)data;
    if (glcd.FontData == d) return;
    glcd.FontData = d;
    if (!(d)) return;
    d += 2;
    glcd.FontWidth = pgm_read_byte_inc(d);
    glcd.FontHeight = pgm_read_byte_inc(d);
    glcd.FontBitsPixel = pgm_read_byte_inc(d);
    glcd.FontFirstChar = pgm_read_byte_inc(d);
    glcd.FontLastChar = pgm_read_byte_inc(d);
    if (glcd.FontBitsPixel & 0x80) { // compressed font
      d = glcd.FontData + (GLCD_FONT_HEADER_SIZE + 1) + (glcd.FontLastChar - glcd.FontFirstChar);
      glcd.FontBitsHeight = pgm_read_byte_inc(d);
      glcd.FontRLE[0] = 1;
      glcd.FontRLE[1] = pgm_read_byte_inc(d);
      glcd.FontRLE[2] = pgm_read_byte_inc(d);
      glcd.FontRLE[3] = pgm_read_byte_inc(d);
    } else {
      glcd.FontBitsHeight = glcd.FontHeight * glcd.FontBitsPixel;
    }

}*/

void Font_Select_Font(const void* data) 
{
    static glcdFontData_t d;

    if(d!=data)
    {
        Font_Set_Window(0,0, 64, 10);
        //->typedef uint16_t glcdFontData_t
        //bergebenen pointer lokalem zuweisen
        d = (glcdFontData_t)data;
        //->glcdData_t glcd; global definiert
        //wenn pointer gleich (es wurde der selbe zeichensatz geladen) dann raus
        if (Font.FontData == d) return;
        //ansonsten pointer zuweisen
        Font.FontData = d;
        //wenn d nicht NULL
        if (!(d)) return;
        //dann:
        //pointe auf: font widt(berspringe filesize)
        d += 2;
        //bernehme die bytes eines nach dem anderen in die globale variable glcd
        Font.FontWidth = pgm_read_byte_inc(d);
        Font.FontHeight = pgm_read_byte_inc(d);
        Font.FontBitsPixel = pgm_read_byte_inc(d);
        Font.FontFirstChar = pgm_read_byte_inc(d);
        Font.FontLastChar = pgm_read_byte_inc(d);

        //wenn msb in fonts per pixel gesetzt (rle faktoren einlesen)
        if (Font.FontBitsPixel & 0x80) { // compressed font
          //hier kommt das feld mit den fontbreiten (muss bersprungen werden)[font_Last_Char - font_First_Char +1]
          //der pointer wird absolut berechnet (GLCD_FONT_HEADER_SIZE=7)
          d = Font.FontData + (GLCD_FONT_HEADER_SIZE + 1) + (Font.FontLastChar - Font.FontFirstChar);
          Font.FontBitsHeight = pgm_read_byte_inc(d);
          Font.FontRLE[0] = 1;
          Font.FontRLE[1] = pgm_read_byte_inc(d);
          Font.FontRLE[2] = pgm_read_byte_inc(d);
          Font.FontRLE[3] = pgm_read_byte_inc(d);
        } else {
          Font.FontBitsHeight = Font.FontHeight * Font.FontBitsPixel;
        }
    }

}

void Font_Draw_Text(const unsigned char* text, unsigned short size, unsigned char flashstored,uint8_t color,uint8_t bgcolor,uint8_t mode) 
{

    unsigned char   flags= (flashstored ? 0x70 : 0x30) | (Font.FontBitsPixel & 0x80) | (Font.Flags.All & 0x07);

                    /*flags


                    0x01:#define MP_CAPTION    0x01 
                         #define GLCD_BMP_TRANSPARENT        0x01
                         // FixedFont ??
                         FixedFont:1,  // don't reorder
                    0x02:
                         LineFeed:1

                    0x04:#define MP_ALLITEMS   0x04
                         #define GLCD_BMP_USECOLORS          0x04
                         VirtualFontRow:1;
                    0x08:
                         #define MP_SELECTED   0x08

                    0x10:// invalidate LCD address pointer
                    0x20:// initialize LCD ??
                    0x40:// flashstored(ob der ausgabetext im flash des avrs liegt, oder lokal global definiert ist - ist hier gleich)
                    0x80:// compresed Font ??

                    */
    
    unsigned char   bitspixel = Font.FontBitsPixel & 0x7F;  //wieviele Bits jeder Pixel bentigt - sozusagen farbtiefe
    
    unsigned char   bitsmask = 0xFF >> (8 - bitspixel);     //bitmaskte (bei zb 2 bits per pixel ist sie 0x03)
    
    unsigned char   FontHeight = Font.FontHeight,           //font hhe - ist fr den ganzen schriftsatz gleich       
                    FontWidth = Font.FontWidth,             //font breite - maximalbreite - kann aber auch fr jeden buchtstaben anders sein dann ists charwidth
                    FontCharSpace = Font.FontCharSpace;     //anzahl der leerspalten zwischen den buchstaben
                    
    unsigned char   FontFirstChar = Font.FontFirstChar,     //erster buchstabe im font
                    FontLastChar = Font.FontLastChar;       //letzer buchstabe im font
                    
    unsigned char   charofs = FontLastChar - FontFirstChar +5;
                                                            //warscheinlich offset bis zum ersten buchstabendatanbereich im font (char offset)
                                                            
    glcdCoord_t     Cursorx = Font.Cursor.x,                //setze lokalen cursor
                    Cursory = Font.Cursor.y;
                    
    glcdCoord_t     Windowx2 = Font.Window.x2 +1,
                    Windowy2 = Font.Window.y2 +1,
                    Windowx1 = Font.Window.x1,
                    Windowy1 = Font.Window.y1;              //setze fenster (grenzt das textfeld ein)
                    
    glcdFontData_t  data, FontData = Font.FontData + GLCD_FONT_HEADER_SIZE;//glcd.fontdata  zeigt auf den anfang des gesamten font datenfeldes
                                                                           //fontdata       zeigt auf das width datanfeld
                                                            //
                                                            
    unsigned short  FontBitsHeight = Font.FontBitsHeight;   //
    unsigned short* colors = &Font.Colors[0];               //
    unsigned char*  rle = &Font.FontRLE[0];                 //

    glcdColor_t     fontbit= 0;      //
    unsigned char   c,              //
                    i,              //
                    width,          //letztendliche breite des jeweiligen buchstabens incl. freistreifen
                    charwidth,      //absolute breite des buchstabens
                                    //FontWidth enthlt die maximalbreite
                    bitsmul,        //
                    pixelcount,     //
                    bitscount,      //
                    leftspace,      //
                    rightspace;     //
                    
    unsigned int    index;          //  
    unsigned short  bits;           //

    unsigned short  nop;           //xxx


    //new vars
    unsigned char   charycnt;
    unsigned char   charxcnt;

    unsigned char   xabs=Font.Cursor.x;
    unsigned char   yabs=Font.Cursor.y;

    unsigned char   glib_loc_draw_cntx,
                    glib_loc_draw_cnty,
                    glib_loc_draw_x,
                    glib_loc_draw_y,
                    glib_loc_draw_fonthight,
                    glib_loc_draw_fontwidth,
                    glcd_lib_draw_pixelcount;

    if ((text == 0) || (Font.FontData == 0)) return;

    for (; size > 0; size--) 
    {

        //text liegt im flash des ucs oder ist lokal global (nicht im flash)
        //hat mit der architektur des avr zu tun
      if (flags & 0x40)
      {
          c = pgm_read_byte_inc(text);

      }
      else
      {
          c = *text++;
      }
        //wenn c null ist -> raus
      if (!(c)) break;
        //wenn c \n (zeilenumbruch) ist

      if (c == '\n')
      { 
        //Cursorx  = Windowx1; //gehe an den anfang des fensters
        //Cursory += FontHeight; //in die nchste zeile
        //if(Cursory + FontHeight > Windowy2) Cursory = Windowy1;  // wenn aus dem bild luft -> text berschreiben
        if (Cursory + FontHeight*2 > Windowy2) 
        {
               break;
        }
        else
        {
                Cursorx  = Windowx1;//nach links im fenster lf
                Cursory += FontHeight;//-5;//eine zeile runter cr
        }
        //flags |= 0x10;  // invalidate LCD address pointer (warum? was bewirkt das)
//        continue;
      }

        //liegt char im bereich der buchstben des fonts
      if ((c < FontFirstChar) || (c > FontLastChar)) continue;




      //FontData zeigt auf das 8te byte im datensatz (witdh feld)
      //
      data = FontData + c - FontFirstChar;//berechnet den offset zur passenden buchstabenbreite im width feld
      
      charwidth = pgm_read_byte(data);//greift die zum buchstaben gehrende breite aus dem datenspeicher...


      if (!(charwidth)) continue;

      width = charwidth;
      if ((flags & 0x04) && (c < 128))
          //bit 0x04 -> virtual font row
         width++;//?breite um einen erhhen wenn bit 2 in flags gesetzt und zeichen kleiner 128
        
      if ((flags & 0x01) && (width < FontWidth)) width = FontWidth; //? FixedFont ??
                                                                    //?fontwidth ist die maximalbreite des fonts
                                                                    //?ist flag bit 0 geseztzt wird die breite immer auf maximum gesetzt
      width += FontCharSpace; //zeichenabstand - leerzeilen zwischen den zeichen..


     //LINE FEED
/*/
      //wenn zeichen > window x breite:
      if (Cursorx + width > Windowx2) 
      {                         // wenn cursorx plus width grer fenster, dann zeilenumbruch
        if (flags & 0x02) //wenn bit dafr gesetzt ist 
        {                       

          if (Cursory + FontHeight*2 > Windowy2) 
          {
              break;
          }
          else
          {
              Cursorx  = Windowx1;//nach links im fenster lf
              Cursory += FontHeight;//-5;//eine zeile runter cr
          }
          //flags |= 0x10;  // invalidate LCD address pointer
        }
        else
        {
            break;
        }
      }
/*/    

        //in bits stehten jetzt die aufs display zu schreibenden bits
        //in bitcount wie viele pixlel in bits zu dem buchstaben gehren 1-8


       //ich schtze:
      //wenn fixed font aktiviert ist, wird der buchstabe mittig gesetzt

/*/


      leftspace = 0;
      rightspace = width - charwidth;
      if (flags & 0x01) { // FixedFont ??
        leftspace = rightspace / 2;
        rightspace -= leftspace;
        if ((leftspace > 0) && (colors[0] == NONE)) {
          flags |= 0x10;
          Cursorx += leftspace;
          width -= leftspace;
          leftspace = 0;
        }
      }

/*/
      /*
      if (flags & 0x20) { // initialize LCD ??
        flags ^= 0x20;
        GLCD_CS_ON();
      #ifdef GLCD_ROTATE
        GLCD_SETMODE(0x30 | GLCD_ROP_WNE);
      #else
        GLCD_SETMODE(0x38 | GLCD_ROP_WNE);
      #endif
        GLCD_SETCOMPARE(NONE);
      }
      
      if (flags & 0x10) { // LCD address pointer invalid ??
        flags ^= 0x10;
        GLCD_WAIT();
        GLCD_CS_PULSE();
        GLCD_WINDOW(Cursorx, Cursory, GLCD_RIGHT, Cursory + FontHeight -1);
        GLCD_SETADDR(Cursorx, Cursory);
        GLCD_STARTDATA();
      }
      */
      
      //->Y nach unten versetzt:Cursorx += width;//gehe mit cursor um buchstabenbreite weiter
            
       /*
      if (leftspace > 0) {
        color = colors[0];
        do {
          i = FontHeight;
          do {
            GLCD_WAIT();
            GLCD_OUT(H8(color));
            GLCD_WAIT();
            GLCD_OUT(L8(color));
          } while (--i);
        } while (--leftspace);
      }*/
      
      //die unteren 3 bits von bitscount : 
      //0->1
      //1->2
      //2->4
      //3->8
      //4->16
      //5->32
      //6->64
      //7->128

      index = 0;
      data = FontData;//zeige auf widths anfang

        //bis hier hin werden komprimierte und unkomp. fonts gleich behandelt...

      //addiert alle breiten der buchstaben zusammen um zu den passenden daten zu kommen.
      if (flags & 0x80)//wenn comp font
      {
          data += charofs;//hier wird die breite des width feldes addiert damit folgend die sizes aus der rle aufaddiert werden knnen
                          //zeige auf rle-sizes: size werte hinter der rle erste size
      }
      //beim unkomprimierten font werden hier die width s zusammengerechnet um letztendlich zum passenden datenbereich zu finden
      //beim comprimierten font werden hier die einzelnen char sizes addiert...feld nach der rle
      for (i = c - FontFirstChar; i > 0; i--)
      {
          index += pgm_read_byte_inc(data);
      }
      
      index *= FontBitsHeight;//anzahl der pixel bis zum buchstabenstart errechnen
      data = FontData + charofs -4;//unc  data zeigt jetzt auf das datenfeld der char data
                                   //comp data zeigt auf den anfang der rle (setzte zeiger zurck auf den anfang der rle)
      if (flags & 0x80) //comp font
      {
        data += charofs; //zeige auf anfang des char datanfeldes (pixeldaten)
        data += index;   //addiere den index offset bis zum datenbereich des selektierten buchstabens
                         //zeiger steht auf buchstabendaten
        bits = 0;
        bitscount = 0;
      } 
      else //uncomp font
      {
        bitscount = index & 0x07;//startpixel im byte ermitteln
        index >>= 3;// index enthlt die zahl der pixel bis zum buchstabenstart muss also 
                    //durch 8 geteilt werden (>>3) um das passende byte zu finden
        data += index;//zum startpunkt in den fontdaten fr den selektierten buchstaben
                         //zeiger steht auf buchstabendaten

        bits = pgm_read_byte_inc(data) >> bitscount;//erstes byte lesen und die bits bis zum starbit hinschieben
        bitscount = 8 - bitscount;
      }

      //hier wird das erste byte des fonts in die verarbeitungsroutinen geladen, die bits aus dem byte werden dabei immer
      //genau hinten angefgt. bits ist eine 16bit variable,  1 byte wird immer dann nachgeschoben, wenn weniger als 8 bit enthalten sind
      
      if (bitscount < 8) 
      {
        bitsmul = pgm_read_byte(&powerof2[bitscount & 0x07]);  //read_byte wird bentigt um den multiplikator von powerof auszulesen0
        bitscount += 8;
        bits |= pgm_read_byte_inc(data) * bitsmul;    // faster as shifting
      }
      //pixelcount   unused till now
      //bitpixel     enthlt die anzahl der bits pro pixel, bei sw 1 (farbwerte)

        glcd_lib_draw_pixelcount = 1;

        glib_loc_draw_fontwidth=charwidth;
        glib_loc_draw_fonthight=FontHeight;

        glib_loc_draw_x=Cursorx;
        glib_loc_draw_y=Cursory+FontHeight-1;

        glib_loc_draw_cntx=0;
        glib_loc_draw_cnty=0;

      while(glib_loc_draw_cntx<glib_loc_draw_fontwidth) 
      {
        glib_loc_draw_cnty = 0;
        
        while(glib_loc_draw_cnty<glib_loc_draw_fonthight)
        {

            if (glcd_lib_draw_pixelcount ==1) 
            {  //if (glcd_lib_draw_pixelcount ==1)
                //glcd_lib_draw_pixelcount++;
                if (flags & 0x80) 
                { // compresed Font ??
                    glcd_lib_draw_pixelcount = rle[bits & 0x03];//rle index holen, und anzahl zu schreibender pixel auslesen
                    bits >>= 2;//2 rle index bits weg schieben(sind immer 2, da rle immer nur 4 werte beinhaltet9
                    bitscount -= 2;//2 rle index bits abziehen
                }
                fontbit = colors[bits & bitsmask];//farbindex aus den daten ermitteln
                                                 //pixelbit ausmaskieren und ls indes fr die farbtabelle verwenden
                                                    //bitmaskte (bei zb 2 bits per pixel ist sie 0x03)

                bitscount -= bitspixel;  //in bitcount stehen wie viele bits(nicht pixel bei komp. font) in bits stehen 
                                         //(bits enthlt byte aus dem speicher)
                                         //bitpixel: wieviel bits bentigt ein pixel: bei sw =1 0=wei, 1=schwarz zb.
                //???

                //bitmaskte (bei zb 2 bits per pixel ist sie 0x03)
                //bits enthlt die aktuellen pixelinformationen des gesamten bytes/bereiches
                bits >>= bitspixel;//ausgegebenen pixel wegschiften
                
                if (bitscount < 8) 
                { // read in advance while we wait for SPI
                    bitsmul = pgm_read_byte(&powerof2[bitscount & 0x07]);//ist fr das nachholen der pixeldaten (nach dieser schleife)
                    bitscount += 8;                             //counter um 8 erhhen
                    bits |= pgm_read_byte_inc(data) * bitsmul;   // faster as shifting //neue 8 pixeldaten hinten anfgen (erst shiften und dann anfgen)
                }                                               //bits (16bit var)enthlt die aktuellen pixelinformationen des gesamten bytes/bereiches


            }
            else
            {
                glcd_lib_draw_pixelcount--;
            }
            //GLCD_WAIT();
            //GLCD_OUT(H8(color));
            //nachstes byte hinten anfgen

            //GLCD_WAIT();
            //GLCD_OUT(L8(color));
            if(fontbit)
            {
                SLM1606_Set_Pixel(glib_loc_draw_x+glib_loc_draw_cntx,glib_loc_draw_y-glib_loc_draw_cnty,color);
            }
            else
            {
                if(mode)
                SLM1606_Set_Pixel(glib_loc_draw_x+glib_loc_draw_cntx,glib_loc_draw_y-glib_loc_draw_cnty,bgcolor);

            }
            glib_loc_draw_cnty++;
        }

        glib_loc_draw_cntx++;
      } 

      Cursorx += width;//hier her versetzt:gehe mit cursor um buchstabenbreite weiter

      /*if (rightspace > 0) {
        color = 1;//colors[0];
        if (color == NONE) {
          flags |= 0x10; // ab >= 11 Pixel macht das Neusetzen des Windows Sinn, ergo FontHeight * rightspace >= 11, gilt auf fr leftspace, hier ignorieren wir das aber
        } else {
          do {
            i = FontHeight;
            do {
              GLCD_WAIT();
              GLCD_OUT(H8(color));
              GLCD_WAIT();
              GLCD_OUT(L8(color));
            } while (--i);
          } while (--rightspace);
        }
      }*/
    }
    /*
    if (!(flags & 0x20)) { // have LCD initialized, anything done ??
      GLCD_WAIT();
      GLCD_CS_PULSE();
      GLCD_RESETWINDOW();
      GLCD_SETMODE(0x30);
      GLCD_CS_OFF();
    }
    */

    //Cursorx += width;//hier her versetzt:gehe mit cursor um buchstabenbreite weiter

    Font.Cursor.x = Cursorx;
    Font.Cursor.y = Cursory;
}



