

#include "Sced_Disp_If_Used.h"
#include "inttypes.h"
#include "lcdg.h"
#include "Sced.h"
#include "Font.h"
#include "Font_User.h"
#ifdef AVR
#include "slm1606m.h"
#endif


unsigned char Sced_Disp_If_Used_Get_Color(unsigned char color) 
{
    if(color>1)
    {
        return(color+=14);
    }
    else
    {
        return(color);
    }

}

void Sced_Disp_If_Used(uint8_t x,uint8_t y,uint8_t param1, uint8_t param2, uint8_t color, uint8_t bgcolor, uint8_t command)
{
    //translate color to lib spezific format
    color=Sced_Disp_If_Used_Get_Color(color);
    bgcolor=Sced_Disp_If_Used_Get_Color(bgcolor);
    switch(command)
    {
        case SCED_DISP_IF_USED_COM_PIXEL:
        {
            SLM1606_setPixel(x,y,color);
            break;
        }
        case SCED_DISP_IF_USED_COM_LINE:
        {
            GRF_drwline(x,y,param1,param2,color);
            break;
        }
        case SCED_DISP_IF_USED_COM_BOX:
        {
            lcdg_box(x,y,param1,param2,color);
            break;
        }
        case SCED_DISP_IF_USED_COM_FBOX:
        {
            lcdg_fillbox(x,y,param1,param2,color);
            break;
        }
        case SCED_DISP_IF_USED_COM_CHAR:
        {
            Font_Write_Char(x,y,color,bgcolor,param1,param2);
            break;
        }
        case SCED_DISP_IF_USED_COM_MONTH:
        {
            Font_Show_Month(x,y,param1,color);
            break;
        }
        case SCED_DISP_IF_USED_COM_YEAR:
        {
            Font_Show_Year(x,y,param1|(param2<<8),color);
            break;
        }
    }
}
