#ifndef INTYPES_H
#define INTYPES_H

#ifdef __cplusplus
extern "C"
{
#endif

#define PROGMEM
#define __attribute__
#define progmem

//#define     pgm_read_byte_inc(d)                (*((const unsigned char *) (d))++)
#define     pgm_read_byte_inc(d)                (*((d))++)
#define     pgm_read_byte(d)                    (*(d))


typedef unsigned int uint32_t;
typedef unsigned int uint16_t;
typedef unsigned char uint8_t;
typedef int int16_t;
typedef char int8_t;

void SLM1606_setPixel (unsigned char x, unsigned char y, unsigned char col);
void SLM1606M_set_on_pixel (unsigned char x, unsigned char y, unsigned char col);
void SLM1606_Set_Pixel (uint8_t x, uint8_t y, uint8_t col);

uint16_t uart_getc(void);
int main_prog (void);
int main_ini (void);
void action_set_par (uint8_t par);
void Timer_Interrupt (void);
//unsigned char FONT_8_3x5[];
//void Font_Write_Char(unsigned char x, unsigned char y, unsigned char color,char letter,uint8_t mode);

#ifdef __cplusplus
}
#endif


#endif