
#define LCDG_WHITE 0
#define LCDG_BLACK 1

#define MAXLCDG_X 128
#define MAXLCDG_Y 64

void lcdg_init();
void lcdg_drawpixel(unsigned char x, unsigned char y, unsigned char color);
void lcdg_putc(unsigned char asci,int x, int y, int color);

void lcdg_putc_APE(unsigned char asci,int x, int y, int color);//Nachgebastelt fr APE Fonts

void lcdg_circle(unsigned char xCenter, unsigned char yCenter, 
                 unsigned char radius, unsigned char color);

void lcdg_filledcircle(unsigned char xCenter, unsigned char yCenter, 
                 unsigned char radius, unsigned char color);

void lcdg_fillbox(int x1, int y1, int x2, int y2, int color );
void GRF_drwline(int Ax, int Ay, int Bx,
               int By, unsigned char Color);

void lcdg_box(int x1, int y1, int x2, int y2, int color );
void lcdg_gotoxy(int x, int y);
void lcdg_gotoxypixel(int x, int y);
int lcdg_maxx(void);
int lcdg_maxy(void);
void lcdg_incpos(void);
void lcdg_returnpos(void);

/*void oprintf(char *fmt, ...);*/
